<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/tile/TerrainTile.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_f656290b9017852ece87b8a3712178e6.html">tile</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">TerrainTile.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="TerrainTile_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &quot;<a class="code" href="Tile_8hpp.html">Tile.hpp</a>&quot;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &lt;<a class="code" href="Attributes_8hpp.html">resources/Attributes.hpp</a>&gt;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>{</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">   11</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">TerrainType</a> { <a class="code hl_enumvalue" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0aa3030e42cd8f04255711905a9182399f">GRASS</a>, <a class="code hl_enumvalue" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0a2add2964642f39099cb51edf4a4f5a70">WATER</a>, <a class="code hl_enumvalue" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0ab9d57bb7fb2984cd72dc41bf4eeb0c44">WATERDOWN</a>, <a class="code hl_enumvalue" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0ab12b5773bb0f2737190469ecc326ad32">CANAL</a>, <a class="code hl_enumvalue" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0ac0f8e24cf041639c4fc457ebec9490eb">TREE</a> };</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1TerrainTile.html">TerrainTile</a> : <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1Tile.html">Tile</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#a54c61e664ee3703e05b9db3a6c0e2f5a">   16</a></span>    <a class="code hl_function" href="classgg_1_1TerrainTile.html#a54c61e664ee3703e05b9db3a6c0e2f5a">TerrainTile</a>(<span class="keyword">const</span> <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> &amp;attributes);</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#a512736a8f4cf1e4ecdb71f22d71f70c3">   17</a></span>    <a class="code hl_function" href="classgg_1_1TerrainTile.html#a512736a8f4cf1e4ecdb71f22d71f70c3">~TerrainTile</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#ab4d34dd713679c8282baf6c77fde4711">   19</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#ab4d34dd713679c8282baf6c77fde4711">IsWater</a>() -&gt; bool;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#ae7b2a5d30ac9342a349517bf27018bd4">   20</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#ae7b2a5d30ac9342a349517bf27018bd4">IsGrass</a>() -&gt; bool;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#ac5124cacde85e3abf6c873e6570a0c0d">   22</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#ac5124cacde85e3abf6c873e6570a0c0d">GetAttributes</a>() -&gt; <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> <span class="keyword">override</span>;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#a4197b667e2f2ee4237e0602f1658620b">   23</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#a4197b667e2f2ee4237e0602f1658620b">GetTileType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">TileType</a> <span class="keyword">override</span>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#abd15c8f91d6e443f677a9368145db8aa">   25</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#abd15c8f91d6e443f677a9368145db8aa">TerrainTypeToString</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">TerrainType</a> terrainType) -&gt; std::string;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#ab9b230c3715d4db41e6b89d53d196fc6">   26</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#ab9b230c3715d4db41e6b89d53d196fc6">StringToTerrainType</a>(<span class="keyword">const</span> std::string &amp;str) -&gt; <a class="code hl_enumeration" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">TerrainType</a>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#ae34f60e6d1d82369e13f7bf772d0f9d1">   28</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#ae34f60e6d1d82369e13f7bf772d0f9d1">GetTerrainType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">TerrainType</a>;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="classgg_1_1TerrainTile.html#a9b960122be041933be46eaa1f80824c9">   30</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1TerrainTile.html#a9b960122be041933be46eaa1f80824c9">Align</a>() <span class="keyword">override</span>;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    <a class="code hl_enumeration" href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">TerrainType</a> mTerrainType;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>};</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aAttributes_8hpp_html"><div class="ttname"><a href="Attributes_8hpp.html">Attributes.hpp</a></div></div>
<div class="ttc" id="aTile_8hpp_html"><div class="ttname"><a href="Tile_8hpp.html">Tile.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html"><div class="ttname"><a href="classgg_1_1Attributes.html">gg::Attributes</a></div><div class="ttdef"><b>Definition:</b> Attributes.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html"><div class="ttname"><a href="classgg_1_1TerrainTile.html">gg::TerrainTile</a></div><div class="ttdef"><b>Definition:</b> TerrainTile.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_a4197b667e2f2ee4237e0602f1658620b"><div class="ttname"><a href="classgg_1_1TerrainTile.html#a4197b667e2f2ee4237e0602f1658620b">gg::TerrainTile::GetTileType</a></div><div class="ttdeci">auto GetTileType() -&gt; TileType override</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_a512736a8f4cf1e4ecdb71f22d71f70c3"><div class="ttname"><a href="classgg_1_1TerrainTile.html#a512736a8f4cf1e4ecdb71f22d71f70c3">gg::TerrainTile::~TerrainTile</a></div><div class="ttdeci">~TerrainTile() override=default</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_a54c61e664ee3703e05b9db3a6c0e2f5a"><div class="ttname"><a href="classgg_1_1TerrainTile.html#a54c61e664ee3703e05b9db3a6c0e2f5a">gg::TerrainTile::TerrainTile</a></div><div class="ttdeci">TerrainTile(const Attributes &amp;attributes)</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_a9b960122be041933be46eaa1f80824c9"><div class="ttname"><a href="classgg_1_1TerrainTile.html#a9b960122be041933be46eaa1f80824c9">gg::TerrainTile::Align</a></div><div class="ttdeci">void Align() override</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_ab4d34dd713679c8282baf6c77fde4711"><div class="ttname"><a href="classgg_1_1TerrainTile.html#ab4d34dd713679c8282baf6c77fde4711">gg::TerrainTile::IsWater</a></div><div class="ttdeci">auto IsWater() -&gt; bool</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_ab9b230c3715d4db41e6b89d53d196fc6"><div class="ttname"><a href="classgg_1_1TerrainTile.html#ab9b230c3715d4db41e6b89d53d196fc6">gg::TerrainTile::StringToTerrainType</a></div><div class="ttdeci">static auto StringToTerrainType(const std::string &amp;str) -&gt; TerrainType</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_abd15c8f91d6e443f677a9368145db8aa"><div class="ttname"><a href="classgg_1_1TerrainTile.html#abd15c8f91d6e443f677a9368145db8aa">gg::TerrainTile::TerrainTypeToString</a></div><div class="ttdeci">static auto TerrainTypeToString(const TerrainType terrainType) -&gt; std::string</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_ac5124cacde85e3abf6c873e6570a0c0d"><div class="ttname"><a href="classgg_1_1TerrainTile.html#ac5124cacde85e3abf6c873e6570a0c0d">gg::TerrainTile::GetAttributes</a></div><div class="ttdeci">auto GetAttributes() -&gt; Attributes override</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_ae34f60e6d1d82369e13f7bf772d0f9d1"><div class="ttname"><a href="classgg_1_1TerrainTile.html#ae34f60e6d1d82369e13f7bf772d0f9d1">gg::TerrainTile::GetTerrainType</a></div><div class="ttdeci">auto GetTerrainType() -&gt; TerrainType</div></div>
<div class="ttc" id="aclassgg_1_1TerrainTile_html_ae7b2a5d30ac9342a349517bf27018bd4"><div class="ttname"><a href="classgg_1_1TerrainTile.html#ae7b2a5d30ac9342a349517bf27018bd4">gg::TerrainTile::IsGrass</a></div><div class="ttdeci">auto IsGrass() -&gt; bool</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html"><div class="ttname"><a href="classgg_1_1Tile.html">gg::Tile</a></div><div class="ttdef"><b>Definition:</b> Tile.hpp:21</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">gg::TileType</a></div><div class="ttdeci">TileType</div><div class="ttdef"><b>Definition:</b> Tile.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_a3a093fefaeb8d2d7b35b1356e2ea5ad0"><div class="ttname"><a href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0">gg::TerrainType</a></div><div class="ttdeci">TerrainType</div><div class="ttdef"><b>Definition:</b> TerrainTile.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_a3a093fefaeb8d2d7b35b1356e2ea5ad0a2add2964642f39099cb51edf4a4f5a70"><div class="ttname"><a href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0a2add2964642f39099cb51edf4a4f5a70">gg::TerrainType::WATER</a></div><div class="ttdeci">@ WATER</div></div>
<div class="ttc" id="anamespacegg_html_a3a093fefaeb8d2d7b35b1356e2ea5ad0aa3030e42cd8f04255711905a9182399f"><div class="ttname"><a href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0aa3030e42cd8f04255711905a9182399f">gg::TerrainType::GRASS</a></div><div class="ttdeci">@ GRASS</div></div>
<div class="ttc" id="anamespacegg_html_a3a093fefaeb8d2d7b35b1356e2ea5ad0ab12b5773bb0f2737190469ecc326ad32"><div class="ttname"><a href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0ab12b5773bb0f2737190469ecc326ad32">gg::TerrainType::CANAL</a></div><div class="ttdeci">@ CANAL</div></div>
<div class="ttc" id="anamespacegg_html_a3a093fefaeb8d2d7b35b1356e2ea5ad0ab9d57bb7fb2984cd72dc41bf4eeb0c44"><div class="ttname"><a href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0ab9d57bb7fb2984cd72dc41bf4eeb0c44">gg::TerrainType::WATERDOWN</a></div><div class="ttdeci">@ WATERDOWN</div></div>
<div class="ttc" id="anamespacegg_html_a3a093fefaeb8d2d7b35b1356e2ea5ad0ac0f8e24cf041639c4fc457ebec9490eb"><div class="ttname"><a href="namespacegg.html#a3a093fefaeb8d2d7b35b1356e2ea5ad0ac0f8e24cf041639c4fc457ebec9490eb">gg::TerrainType::TREE</a></div><div class="ttdeci">@ TREE</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
